local dewdrop = DewdropLib:GetInstance('1.0')
local metro = Metrognome:GetInstance('1')
local jostle = JostleLib:GetInstance('1.0')

ExpRepGlueFu = FuBarPlugin:new({
	name          = ExpRepGlueFuLocals.NAME,
	description   = ExpRepGlueFuLocals.DESCRIPTION,
	version       = "1.1." .. string.sub("$Revision: 1253 $", 12, -3),
	releaseDate   = string.sub("$Date: 2006-04-30 21:44:32 -0500 (Sun, 30 Apr 2006) $", 8, 17),
	aceCompatible = 103,
	fuCompatible  = 102,
	author        = "ckknight",
	email         = "ckknight@gmail.com",
	website       = "http://ckknight.wowinterface.com/",
	category      = "combat",
	db            = AceDatabase:new("ExpRepGlueFuDB"),
	cmd           = AceChatCmd:new(ExpRepGlueFuLocals.COMMANDS, ExpRepGlueFuLocals.CMD_OPTIONS),
	loc           = ExpRepGlueFuLocals,
	defaults      =  {
		attach = "TOP"
	},
	hasIcon       = true,
	hideWithoutStandby = true,
	showOnRight   = true,
	hasNoText     = true,
})

function ExpRepGlueFu:Enable()
	MainMenuBarMaxLevelBar:ClearAllPoints()
	MainMenuBarMaxLevelBar:SetPoint("TOPLEFT", MainMenuExpBar, "TOPLEFT")
	MainMenuBarMaxLevelBar:SetPoint("TOPRIGHT", MainMenuExpBar, "TOPRIGHT")
	MainMenuXPBarTexture0:Hide()
	MainMenuXPBarTexture1:Hide()
	MainMenuXPBarTexture2:Hide()
	MainMenuXPBarTexture3:Hide()
	self:Hook("ReputationWatchBar_Update")
	self:RegisterEvent("FUBAR_CHANGED_PANELS")
end

function ExpRepGlueFu:Disable()
	MainMenuExpBar:ClearAllPoints()
	MainMenuExpBar:SetPoint("TOP", MainMenuBar, "TOP")
	MainMenuExpBar:SetWidth(1024)
	MainMenuXPBarTexture0:Show()
	MainMenuXPBarTexture1:Show()
	MainMenuXPBarTexture2:Show()
	MainMenuXPBarTexture3:Show()
	ReputationWatchBarTexture0:Show()
	ReputationWatchBarTexture1:Show()
	ReputationWatchBarTexture2:Show()
	ReputationWatchBarTexture3:Show()
end

function ExpRepGlueFu:Attach(point)
	if self.data.attach ~= point then
		self.data.attach = point
		self:FUBAR_CHANGED_PANELS()
	end
end

function ExpRepGlueFu:IsAttachPoint(point)
	return self.data.attach == point
end

function ExpRepGlueFu:MenuSettings(level, value)
	if level == 1 then
		dewdrop:AddLine(
			'text', self.loc.MENU_ATTACH_TO_TOP,
			'arg1', self,
			'func', not self:IsAttachPoint("TOP") and "Attach",
			'arg2', "TOP",
			'checked', self:IsAttachPoint("TOP"),
			'isRadio', true
		)
		
		dewdrop:AddLine(
			'text', self.loc.MENU_ATTACH_TO_BOTTOM,
			'arg1', self,
			'func', not self:IsAttachPoint("BOTTOM") and "Attach",
			'arg2', "BOTTOM",
			'checked', self:IsAttachPoint("BOTTOM"),
			'isRadio', true
		)
		
		dewdrop:AddLine(
			'text', self.loc.MENU_RETURN_TO_NORMAL,
			'arg1', self,
			'func', not self:IsAttachPoint("NORMAL") and "Attach",
			'arg2', "NORMAL",
			'checked', self:IsAttachPoint("NORMAL"),
			'isRadio', true
		)
	end
end

local lastPanel
function ExpRepGlueFu:FUBAR_CHANGED_PANELS()
	local panel
	if self:IsAttachPoint("TOP") then
		panel = FuBar:GetBottommostTopPanel()
		if panel and panel ~= lastPanel then
			MainMenuExpBar:ClearAllPoints()
			MainMenuExpBar:SetPoint("TOPLEFT", panel.frame, "BOTTOMLEFT")
			MainMenuExpBar:SetPoint("TOPRIGHT", panel.frame, "BOTTOMRIGHT")
			MainMenuExpBar:SetWidth(0)
			MainMenuXPBarTexture0:Hide()
			MainMenuXPBarTexture1:Hide()
			MainMenuXPBarTexture2:Hide()
			MainMenuXPBarTexture3:Hide()
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("TOPLEFT", MainMenuExpBar, "BOTTOMLEFT")
			ReputationWatchBar:SetPoint("TOPRIGHT", MainMenuExpBar, "BOTTOMRIGHT")
			ReputationWatchBar:SetWidth(0)
			local event = event
			setglobal("event", "UPDATE_EXHAUSTION")
			ExhaustionTick_Update()
			setglobal("event", event)
			panel.frame:SetScript("OnSizeChanged", function()
				local event = getglobal("event")
				setglobal("event", "UPDATE_EXHAUSTION")
				ExhaustionTick_Update()
				setglobal("event", event)
			end)
			if lastPanel then
				lastPanel.frame:SetScript("OnSizeChanged", nil)
			end
			self:ReputationWatchBar_Update()
			jostle:RegisterTop(MainMenuExpBar)
			jostle:RegisterTop(ReputationWatchBar)
		end
	elseif self:IsAttachPoint("BOTTOM") then
		panel = FuBar:GetTopmostBottomPanel()
		if panel and panel ~= lastPanel then
			MainMenuExpBar:ClearAllPoints()
			MainMenuExpBar:SetPoint("BOTTOMLEFT", panel.frame, "TOPLEFT")
			MainMenuExpBar:SetPoint("BOTTOMRIGHT", panel.frame, "TOPRIGHT")
			MainMenuExpBar:SetWidth(0)
			MainMenuXPBarTexture0:Hide()
			MainMenuXPBarTexture1:Hide()
			MainMenuXPBarTexture2:Hide()
			MainMenuXPBarTexture3:Hide()
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("BOTTOMLEFT", MainMenuExpBar, "TOPLEFT")
			ReputationWatchBar:SetPoint("BOTTOMRIGHT", MainMenuExpBar, "TOPRIGHT")
			ReputationWatchBar:SetWidth(0)
			local event = event
			setglobal("event", "UPDATE_EXHAUSTION")
			ExhaustionTick_Update()
			setglobal("event", event)
			panel.frame:SetScript("OnSizeChanged", function()
				local event = getglobal("event")
				setglobal("event", "UPDATE_EXHAUSTION")
				ExhaustionTick_Update()
				setglobal("event", event)
			end)
			if lastPanel then
				lastPanel.frame:SetScript("OnSizeChanged", nil)
			end
			self:ReputationWatchBar_Update()
			jostle:RegisterBottom(MainMenuExpBar)
			jostle:RegisterBottom(ReputationWatchBar)
		end
	end
	if not panel then
		MainMenuExpBar:ClearAllPoints()
		MainMenuExpBar:SetPoint("TOP", MainMenuBar, "TOP")
		MainMenuExpBar:SetWidth(1024)
		MainMenuXPBarTexture0:Show()
		MainMenuXPBarTexture1:Show()
		MainMenuXPBarTexture2:Show()
		MainMenuXPBarTexture3:Show()
		ReputationWatchBar_Update()
		if lastPanel then
			lastPanel.frame:SetScript("OnSizeChanged", nil)
		end
		jostle:Unregister(MainMenuExpBar)
		jostle:Unregister(ReputationWatchBar)
	end
	lastPanel = panel
end

local repShown = ReputationWatchBar:IsVisible()
function ExpRepGlueFu:ReputationWatchBar_Update(newLevel)
	self:CallHook("ReputationWatchBar_Update", newLevel)
	ReputationWatchBar:ClearAllPoints()
	if self:IsAttachPoint("TOP") then
		ReputationWatchBar:SetPoint("TOPLEFT", MainMenuExpBar, "BOTTOMLEFT")
		ReputationWatchBar:SetPoint("TOPRIGHT", MainMenuExpBar, "BOTTOMRIGHT")
		ReputationWatchBarTexture0:Hide()
		ReputationWatchBarTexture1:Hide()
		ReputationWatchBarTexture2:Hide()
		ReputationWatchBarTexture3:Hide()
		ReputationWatchBar:SetWidth(0)
	elseif self:IsAttachPoint("BOTTOM") then
		ReputationWatchBar:SetPoint("BOTTOMLEFT", MainMenuExpBar, "TOPLEFT")
		ReputationWatchBar:SetPoint("BOTTOMRIGHT", MainMenuExpBar, "TOPRIGHT")
		ReputationWatchBarTexture0:Hide()
		ReputationWatchBarTexture1:Hide()
		ReputationWatchBarTexture2:Hide()
		ReputationWatchBarTexture3:Hide()
		ReputationWatchBar:SetWidth(0)
	else
		ReputationWatchBar:ClearAllPoints()
		ReputationWatchBar:SetPoint("BOTTOM", MainMenuBar, "TOP")
		ReputationWatchBar:SetWidth(1024)
	end
	if repShown ~= ReputationWatchBar:IsVisible() then
		jostle:Refresh()
		repShown = ReputationWatchBar:IsVisible()
	end
end

ExpRepGlueFu:RegisterForLoad()